#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

#define all(c) c.begin(), c.end()

int main() {

    in(string, t)
    int const p = 41, M = 1e9 + 7;
    int sz = t.size();

    vector<ll> power(sz + 1, 1);
    vector<ll> h(sz + 1, 0);
    for (int i = 0; i < sz; i++) {
        h[i + 1] = (h[i] * p + t[i] - 'a' + 1) % M;
        power[i + 1] = power[i] * p % M;
    }

    auto hh = [&](int l, int r) {
        ll res = (h[r] - h[l] * power[r - l]) % M;
        if (res < 0) res += M;
        return res;
    };

    vector<string> words;
    int idx = 0;
    while (idx < sz / 2) {
        int r = idx + 1;
        while (hh(idx, r) != hh(sz - r, sz - idx)) r++;
        words.push_back(t.substr(idx, r - idx));
        idx = r;
    }

    cout << words.size() << '\n';
    for (auto const &w : words) cout << w << '\n';

}