#include "testlib.h"
#include <numeric>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n");
    int T = opt<int>("t"), wt = opt<int>("wt"), tlim = opt<int>("tlim"), alim = opt<int>("alim");

    vector<int> p(n, 0);
    iota(p.begin(), p.end(), 0);

    vector<int> t(n), a(n);
    for (int &ti : t) ti = rnd.wnext(0, tlim, wt);
    for (int &ai : a) ai = rnd.next(0, alim);

    println(n, T);
    println(p.begin() + 1, p.end());
    println(t.begin() + 1, t.end());
    println(a.begin(), a.end());

}